#pragma once

#include <stdint.h>

// Maximum Arguments Length
#define MAX_TRAMPOLINE_ARGS_SIZE 16777216 // 16 MiB

// System Call Constants
#define TRAMPOLINE_SYSCALL 0x1337
#define QEMU_GUEST_BASE 0x40000 // Arbitrary Value (Aligns To 4k And 16k Page Sizes)

// Pipe Command Structure
struct trampoline_pipe_arguments {
    uint32_t id;
    uint32_t allow_early_return;
    uint32_t length;
};

// Function Types
typedef void (*trampoline_writer_t)(uint32_t guest_addr, const void *data, uint32_t size);
typedef uint32_t (*trampoline_t)(trampoline_writer_t writer, uint32_t id, const unsigned char *args);

// Environmental Variables
#define ENV(name, ...) constexpr const char *name##_ENV = #name;
#include "env-list.h"
#undef ENV