#pragma once

#include <unistd.h>

#include "../main.h"

struct PipeImplementation final : Implementation {
    int main(int argc, char *argv[]) override;
    void memory_writer(uint32_t guest_addr, const void *data, uint32_t size) const override;
private:
    void init();
    void init_child();
    void init_parent() const;
    void loop_child() const;
    // Pipes
    int arguments_pipe[2] = {}; // Send Trampoline Commands From Parent -> Child
    int return_value_pipe[2] = {}; // Send Return Value From Child -> Parent
    // PID
    const pid_t guest_pid = getpid();
};