#include <unistd.h>
#include <vector>

#include <trampoline/types.h>

#include "qemu.h"

// Access QEMU's Memory
void *QEMU::guest_to_host(const uint32_t guest_addr) {
    return (void *) (uintptr_t) (guest_addr + QEMU_GUEST_BASE);;
}

// Run
#define _TO_STRING(x) #x
#define TO_STRING(x) _TO_STRING(x)
int QEMU::run(const int argc, char **argv) {
    // Get Arguments
    std::vector<const char *> new_args;
    new_args.push_back("qemu");
    new_args.push_back("-B");
    new_args.push_back(TO_STRING(QEMU_GUEST_BASE));
    new_args.insert(new_args.end(), argv, argv + argc);
    // Run
    return qemu_main(int(new_args.size()), (char **) new_args.data(), environ);
}
