#pragma once

#include <cstdint>

#ifndef MCPI_HAS_QEMU
#error "QEMU Is Not Present!"
#endif

// QEMU API
extern "C" {
    // Called By Patched QEMU
    int trampoline_handle_syscall(int32_t num, uint32_t arg1, uint32_t arg2);
    // Main
    int qemu_main(int argc, char **argv, char **envp);
}

// Utility Functions
namespace QEMU {
    // Memory
    void *guest_to_host(uint32_t guest_addr);
    // Run
    int run(int argc, char **argv);
}