#include <trampoline/types.h>

#include "../qemu/qemu.h"
#include "main.h"

// Handle Syscall
int trampoline_handle_syscall(const int32_t num, const uint32_t arg1, uint32_t arg2) {
    // Check Syscall
    if (num != TRAMPOLINE_SYSCALL) {
        return 0;
    }
    // Run
    SyscallImplementation::instance->handle_syscall(arg1, arg2);
    return 1;
}
void SyscallImplementation::handle_syscall(const uint32_t arg1, const uint32_t arg2) const {
    const uint32_t id = arg1;
    const unsigned char *args = (const unsigned char *) QEMU::guest_to_host(arg2);
    const uint32_t ret = trampoline(id, args);
    *(uint32_t *) args = ret;
}
