#include <dlfcn.h>

#include "trampoline.h"
#include "memory.h"
#include "log.h"
#include "main.h"

// Memory Writer
const Implementation *stored_impl = nullptr;
static void memory_writer(const uint32_t guest_addr, const void *data, const uint32_t size) {
    stored_impl->memory_writer(guest_addr, data, size);
}

// Run Trampoline
uint32_t Trampoline::operator()(const uint32_t id, const unsigned char *args) const {
    return func(memory_writer, id, args);
}

// Init
void Trampoline::init(const Implementation *impl) {
    stored_impl = impl;
    // Open Library
    void *handle = dlopen("libmedia-layer-trampoline.so", RTLD_NOW);
    if (handle != nullptr) {
        func = (trampoline_t) dlsym(handle, "trampoline");
    }
    if (func == nullptr) {
        ERR("Unable To Load Media Layer Trampoline: %s", dlerror());
    }
}